.386
.model flat,stdcall
option casemap:none

include Force.inc

.code

start:
invoke FindWindow,ADDR ClassName,NULL ; Check if same program is working already
test eax,eax
jz Prog
    invoke MessageBeep,MB_ICONEXCLAMATION	
    invoke ExitProcess,NULL
Prog:
	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov	iccex.dwSize,sizeof INITCOMMONCONTROLSEX    
	mov	iccex.dwICC,ICC_DATE_CLASSES
	invoke InitCommonControlsEx,offset iccex
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,OFFSET WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,OFFSET MenuName
	mov		wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,500
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,addr DlgName,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

SetupListview proc h2List:DWORD
	LOCAL lvc:LV_COLUMN
	
	; /*Listview setup */
	mov lvc.imask,LVCF_TEXT+LVCF_WIDTH
	mov lvc.pszText,offset H1
	mov lvc.lx,100		; ColumnWidth
	invoke SendMessage,h2List, LVM_INSERTCOLUMN,0,addr lvc
	or lvc.imask,LVCF_FMT
	mov lvc.fmt,LVCFMT_LEFT
	mov lvc.pszText,offset H2
	mov lvc.lx,100
	invoke SendMessage,h2List, LVM_INSERTCOLUMN, 1 ,addr lvc
	or lvc.imask,LVCF_FMT
	mov lvc.fmt,LVCFMT_LEFT
	mov lvc.pszText,offset H3
	mov lvc.lx,100
	invoke SendMessage,h2List, LVM_INSERTCOLUMN, 2 ,addr lvc
	or lvc.imask,LVCF_FMT
	mov lvc.fmt,LVCFMT_LEFT
	mov lvc.pszText,offset H4
	mov lvc.lx,180
	invoke SendMessage,h2List, LVM_INSERTCOLUMN, 3 ,addr lvc


     invoke LoadBitmap,hInstance, 251	;/* PUT BACKGROUND*/
     mov hBitmap1,eax

     invoke CreatePatternBrush,hBitmap1
     mov [hBkGrnd],eax







	;============================= PUT HEADERS ===================================
	
	
	invoke SendMessage,hList,LVM_GETHEADER, 0, 0    
	mov hHeader,eax   
	invoke GetWindowLong, hHeader, GWL_EXSTYLE   
	xor eax,HDS_BUTTONS 
	
      invoke SetWindowLong,hHeader, GWL_STYLE, eax   


      mov eax, LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_SUBITEMIMAGES or LVS_EX_GRIDLINES
      invoke   SendMessage, hList, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax
	invoke   SendMessage, hList, LVM_SETTEXTCOLOR, 0, 00000000h
	invoke   SendMessage, hList, LVM_SETBKCOLOR, 0, 00FFFFFFh
	invoke   SendMessage, hList, LVM_SETTEXTBKCOLOR, 0,00A6F7F0h
	ret		
      SetupListview endp




     WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL rect:RECT
	LOCAL ht:DWORD
	LOCAL pt:POINT
	LOCAL LItems:DWORD
	LOCAL	hdc:HDC


	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push		hWin
		pop		hWnd




invoke LoadIcon,hInstance,500
mov hIcon,eax
invoke SendMessage,hWin,WM_SETICON,NULL,hIcon
		
invoke GetDlgItem,hWin,1001
mov hList,eax
		
		;/* Setup listview */
invoke SetupListview,hList
		
invoke SetWindowText,hWin,addr def

yukle:
;======================================================================================================================
;************************************* GET ITEMS FROM FILE ***************************************************************

invoke CreateFile,ADDR DataFileName,GENERIC_READ,NULL,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL


mov oFile,eax
invoke GetFileSize,eax,addr okFileSize
mov okFileSize,eax
invoke GlobalAlloc,GMEM_MOVEABLE or GMEM_ZEROINIT,okFileSize
mov oMemory,eax
invoke GlobalLock,oMemory
mov okuMemory,eax
invoke ReadFile,oFile,okuMemory,okFileSize,ADDR SizeOKU,NULL
mov Aydin,0

invoke lstrlen,okuMemory
or eax,eax
jz close

;===================================== ============================

mov esi,okuMemory


starting:

mov edi,offset textOku ; edi is here for getting every line

;=========================  CHECK IF THERE IS A NEW LINE  ============


lineCheck:     ;  check first character
mov al,[esi]
inc esi
cmp al,174
jne close

;====================================================================================
strLine:     ;     Get Line


mov al,[esi]
inc esi
cmp al,10
je token

mov[edi],al
inc edi
jmp strLine
;=======================================================================================

token:     ; Part Tokens

push esi
mov esi,offset textOku
mov edi,offset text
tokenbas:
mov edi,offset text

tokenise:

mov al,[esi]
inc esi
cmp al,176 
je operation
cmp al,13  
je operation
mov [edi],al
inc edi

jmp tokenise



operation:
inc world

.if world==1

mov eax,Aydin

mov lvi.iSubItem,0
invoke SendMessage,hList,LVM_INSERTITEM,0,addr lvi
mov lvi.iItem,eax

.elseif world==4
inc lvi.iSubItem
invoke SendMessage,hList,LVM_SETITEM,0,addr lvi
inc Aydin
mov world,0
pop esi
xor eax,eax
clearT:
mov text[eax],0
inc eax
cmp eax,500
jne clearT

jmp starting

.else
inc lvi.iSubItem
invoke SendMessage,hList,LVM_SETITEM,0,addr lvi
.endif


xor eax,eax
clr2:
mov text[eax],0
inc eax
cmp eax,MAX_STRING
jne clr2
lea edi,text 
jmp tokenbas


close:
invoke GlobalUnlock,okuMemory
invoke GlobalFree,oMemory
invoke CloseHandle,oFile



;=========================================================================================================================




.ELSEIF uMsg == WM_ERASEBKGND				
		push wParam
            pop hdc
		invoke GetClientRect, hWin,ADDR rect
		invoke FillRect, hdc,ADDR rect, hBkGrnd   
		ret	

		
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,hIcon
Invoke SendMessage,hList,LVM_DELETEALLITEMS,0,0
jmp yukle

invoke GetDlgItem,hWin,1001
mov hList,eax
		
		;/* Setup listview */
invoke SetupListview,hList
invoke SetWindowText,hWin,addr def

			
		;/* ADD ITEM */
		.elseif eax==IDM_ADD
		invoke DialogBoxParam,hInstance,IDD_DLG1,hWin,offset AddProc,NULL


		;/* Deleting selected item from listview */
		.elseif eax==IDM_DELETE
            .if Aydin!=0			

		invoke SendMessage,hList,LVM_GETNEXTITEM,-1,LVNI_FOCUSED
		.if eax!=-1

            invoke DialogBoxParam,hInstance,IDD_DLG2,hWin,addr ShowProc,eax

					
						.else
					invoke MessageBox,NULL,addr sec,0,MB_ICONEXCLAMATION
				.endif
		

           .endif
.endif		


	    .elseif eax==WM_CLOSE
         
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp
;============================================ADDPROC===============================================================
AddProc proc hAddDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL lv_findinfo: LV_FINDINFO 

.if uMsg==WM_CLOSE

invoke EndDialog,hAddDlg,NULL

.elseif uMsg==WM_INITDIALOG


invoke LoadIcon,hInstance,500
mov hIcon,eax
invoke SendMessage,hAddDlg,WM_SETICON,NULL,hIcon

invoke GetDlgItem,hAddDlg,IDC_EDT1
invoke SetFocus,eax

.elseif uMsg==WM_COMMAND
	
.if wParam==IDC_BTN1
invoke SendMessage,hAddDlg,WM_CLOSE,NULL,NULL

.elseif wParam==IDC_BTN2 
invoke GetDlgItemText,hAddDlg,IDC_EDT1,addr text,MAX_STRING
invoke lstrlen,addr text
.if eax==0
invoke MessageBeep,NULL
invoke MessageBox,NULL,addr bos,0,0
je cik
.endif
	


      mov ecx,1000
	mul ecx
	invoke GlobalAlloc,GPTR,ecx 
	mov aMemory,eax 
	invoke GlobalLock,aMemory
	mov aydMemory,eax

			
                  invoke lstrcat,aydMemory,addr ayb
                  invoke GetDlgItemText,hAddDlg,IDC_EDT1,addr text,MAX_STRING
                                 
                  invoke lstrcat,aydMemory,addr text
                  invoke lstrcat,aydMemory,addr ays                
			mov lvi.iSubItem,0
			invoke SendMessage,hList,LVM_INSERTITEM,0,addr lvi
			mov lv_findinfo.flags,LVFI_STRING
			mov lv_findinfo.psz,offset text
			invoke SendMessage,hList,LVM_FINDITEM,-1,addr lv_findinfo
			mov lvi.iItem,eax

			invoke GetDlgItemText,hAddDlg,IDC_EDT2,addr text,MAX_STRING
                  invoke lstrcat,aydMemory,addr text
                  invoke lstrcat,aydMemory,addr ays
			inc lvi.iSubItem
			invoke SendMessage,hList,LVM_SETITEM,0,addr lvi

			invoke GetDlgItemText,hAddDlg,IDC_EDT3,addr text,MAX_STRING
                  invoke lstrcat,aydMemory,addr text
                  invoke lstrcat,aydMemory,addr ays
			inc lvi.iSubItem
			invoke SendMessage,hList,LVM_SETITEM,0,addr lvi

			invoke GetDlgItemText,hAddDlg,IDC_EDT4,addr text,MAX_STRING
                  invoke lstrcat,aydMemory,addr text
                  invoke lstrcat,aydMemory,addr ayc
			inc lvi.iSubItem
			invoke SendMessage,hList,LVM_SETITEM,0,addr lvi

			inc Aydin
			invoke SendMessage,hAddDlg,WM_CLOSE,NULL,NULL
		

invoke CreateFile,ADDR DataFileName,GENERIC_WRITE,NULL,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL





mov aFile,eax
invoke SetFilePointer,aFile,0,NULL,FILE_END

invoke lstrlen,aydMemory
invoke WriteFile,aFile,aydMemory,eax,addr yukleSIZE,NULL

invoke GlobalUnlock,aydMemory
invoke GlobalFree,aMemory
invoke CloseHandle,aFile

cik:		


		.endif

.else 
	mov eax,FALSE
	ret
.endif
mov eax,TRUE


ret
AddProc endp
;==================================================================================================================

ShowProc proc hEditDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
mov eax, uMsg
.if eax==WM_INITDIALOG

invoke LoadIcon,hInstance,500
mov hIcon,eax
invoke SendMessage,hEditDlg,WM_SETICON,NULL,hIcon
invoke lstrcpy,addr text,addr emptystring
	
	mov lvi.iSubItem,0
	invoke SendMessage,hList,LVM_GETITEMTEXT,lParam,addr lvi
	invoke SetDlgItemText,hEditDlg,IDC_EDT8,addr text
      invoke lstrcat,addr addBuffer,addr ayb
      invoke lstrcat,addr addBuffer,addr text
      invoke lstrcat,addr addBuffer,addr ays
	inc lvi.iSubItem
	invoke lstrcpy,addr text,addr emptystring
	invoke SendMessage,hList,LVM_GETITEMTEXT,lParam,addr lvi
	invoke SetDlgItemText,hEditDlg,IDC_EDT9,addr text  
      invoke lstrcat,addr addBuffer,addr text
      invoke lstrcat,addr addBuffer,addr ays
	inc lvi.iSubItem
	invoke lstrcpy,addr text,addr emptystring
	invoke SendMessage,hList,LVM_GETITEMTEXT,lParam,addr lvi
	invoke SetDlgItemText,hEditDlg,IDC_EDT10,addr text
      invoke lstrcat,addr addBuffer,addr text
      invoke lstrcat,addr addBuffer,addr ays
	inc lvi.iSubItem
	invoke lstrcpy,addr text,addr emptystring
	invoke SendMessage,hList,LVM_GETITEMTEXT,lParam,addr lvi
	invoke SetDlgItemText,hEditDlg,IDC_EDT11,addr text
	invoke lstrcat,addr addBuffer,addr text
      invoke lstrcat,addr addBuffer,addr ayc

;invoke MessageBox,NULL,addr addBuffer,0,0 ;====================> DOSYADAN SILINECEK
		
	
	.elseif eax==WM_COMMAND
		mov eax,wParam
			.if ax==IDC_BTN3

				invoke SendMessage,hEditDlg,WM_CLOSE,NULL,NULL

.elseif ax==IDC_BTN4
invoke SendMessage,hList,LVM_GETNEXTITEM,-1,LVNI_FOCUSED
invoke SendMessage,hList,LVM_DELETEITEM,eax,0
invoke SendMessage,hEditDlg,WM_CLOSE,NULL,NULL





;=========================================================================================================================
invoke CreateFile,ADDR DataFileName,GENERIC_READ,NULL,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL


mov sFile,eax
invoke GetFileSize,eax,addr sFileSize
mov sFileSize,eax
invoke GlobalAlloc,GMEM_MOVEABLE or GMEM_ZEROINIT,sFileSize
mov sMemory,eax
invoke GlobalLock,sMemory
mov srtMemory,eax
invoke ReadFile,sFile,srtMemory,sFileSize,ADDR SpareRW,NULL




;*************************************************************************************************************************
      mov ecx,1000
	mul ecx
	invoke GlobalAlloc,GPTR,ecx ;Kayit X 1000 kadar bir alan bosaltiliyor,GPTR standart kullaniliyor
	mov exMemory,eax ; ayrilan alan hMemory'e yukleniyor
	invoke GlobalLock,exMemory;belirnenen bos alan kilitleniyor
	mov extMemory,eax


      ;invoke CreateFile,ADDR SpareFileName,GENERIC_WRITE,NULL,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
      invoke CreateFile,addr SpareFileName,GENERIC_READ+GENERIC_WRITE,FILE_SHARE_READ,0,\
		OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
      mov exFile,eax
      invoke SetFilePointer,exFile,0,NULL,FILE_END



;=========================================================================================================================


;================ DOSYA BOSMU DOLUMU =================================
invoke lstrlen,srtMemory
or eax,eax
jz finish
;===================================== PROGRAM GIRISI ======================================

giris:
mov esi,srtMemory

baslangic:
lea edi,sort1
mov al,[esi]
cmp al,174
jne finish
basla:
mov al,[esi]
inc esi
mov [edi],al
inc edi
cmp al,10
je basNokta
jmp basla

;==============================================================================================

basNokta:

invoke lstrcmpi,addr sort1,addr addBuffer
.if eax==0
xor eax,eax
clearA:
mov sort1[eax],0
inc eax
cmp eax,50
jne clearA
jmp baslangic
.endif




invoke lstrcat,extMemory,addr sort1
xor eax,eax
clearB:
mov sort1[eax],0
inc eax
cmp eax,50
jne clearB
jmp baslangic




finish:




invoke lstrlen,extMemory
invoke WriteFile,exFile,extMemory,eax,addr SpareRW,NULL


invoke GlobalUnlock,extMemory
invoke GlobalFree,exMemory
invoke CloseHandle,exFile

invoke GlobalFree,sMemory
invoke GlobalUnlock,srtMemory
invoke CloseHandle,sFile



Exchange:
;invoke MessageBox,NULL,addr sort1,0,0
invoke DeleteFile,addr DataFileName
invoke MoveFile,addr SpareFileName,addr DataFileName

xor eax,eax
clearBF:
mov addBuffer[eax],0
inc eax
cmp eax,150
jne clearBF

xor eax,eax
clearBT:
mov text[eax],0
inc eax
cmp eax,500
jne clearBT




dec Aydin



;=========================================================================================================================
.endif

			
	.elseif eax==WM_CLOSE


		invoke EndDialog,hEditDlg,NULL
			
	.else 
		mov eax,FALSE
		ret
	.endif

	mov eax,TRUE
	ret
	
ShowProc endp








end start
